package com.eactive.eai.transformer.function.convert;

import java.util.Stack;

import org.nfunk.jep.ParseException;
import org.nfunk.jep.function.PostfixMathCommand;

import com.eactive.eai.transformer.function.util.CodeConversion;
import com.eactive.eai.transformer.util.IConv;


/**
 * EBCDIC 값을 ASCII 전각으로 변환하는 함수
 * 입력 값은 byte[], 결과는 byte[]임.
 */
public class EBCDIC2ASCIIS extends PostfixMathCommand {
    public EBCDIC2ASCIIS() {
        numberOfParameters = 1;
    }

    public void run(Stack inStack) throws ParseException {
        checkStack(inStack);

        Object param = inStack.pop();
        byte[] value = null;
        try {
            if (param instanceof String) {
                value = ((String) param).getBytes();
            } else if (param instanceof byte[]) {
                value = (byte[]) param;
            } else if (param instanceof Double) {
            	if (((Double) param).doubleValue() == Math.round(((Double) param).doubleValue())) {
            		value = new Long(Math.round(((Double) param).doubleValue())).toString().getBytes();
            	} else {
                    value =((Number) param).toString().getBytes();
            	}
            } else if (param instanceof Number) {
                value = ((Number) param).toString().getBytes();
            } else if (param == null) {
//                inStack.push(null);
//                return;
            	inStack.push(new byte[0]);
            	return;
            } else {
                throw new ParseException("Function의 파라미터 인수가 byte[], String이 아닙니다. : " + param);
            }
            
            String simple = IConv.ebcdicToASCII(value);
            String seal = CodeConversion.simpleToSeal(simple);
            inStack.push(seal.getBytes());
        } catch (Exception e) {
            //throw new ExecutionException(e.getMessage(), parameters, e);
            throw new ParseException(e.getMessage(), e);
        }
    }
}
